Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Views/DataEditorView.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Views/DataEditorView.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Views/DataEditorView.cs	(revision 14777)
@@ -2,10 +2,14 @@
 
 namespace HeuristicLab.BenchmarkSuite.Views {
+
+  using HeuristicLab.BenchmarkSuite.Problems;
   using HeuristicLab.Core.Views;
   using HeuristicLab.MainForm;
 
   [View("Push Expression Selection Editor")]
-  [Content(typeof(IBenchmarkSuiteDataDescriptor), true)]
+  [Content(typeof(Data), true)]
   public partial class DataEditorView : NamedItemView {
+    private const string ValueSeparator = ", ";
+
     public DataEditorView() {
       InitializeComponent();
@@ -20,12 +24,12 @@
       var row = dataGridView.Rows[e.RowIndex];
 
-      var inputArgs = new string[Content.InputArgumentCount];
-      for (var i = 0; i < Content.InputArgumentCount; i++) {
+      var inputArgs = new string[Content.InputArgumentTypes.Length];
+      for (var i = 0; i < Content.InputArgumentTypes.Length; i++) {
         inputArgs[i] = row.Cells[i].Value.ToString();
       }
 
-      var outputArgs = new string[Content.OutputArgumentCount];
-      for (var i = 0; i < Content.OutputArgumentCount; i++) {
-        outputArgs[i] = row.Cells[Content.InputArgumentCount + i].Value.ToString();
+      var outputArgs = new string[Content.OutputArgumentTypes.Length];
+      for (var i = 0; i < Content.OutputArgumentTypes.Length; i++) {
+        outputArgs[i] = row.Cells[Content.InputArgumentTypes.Length + i].Value.ToString();
       }
 
@@ -33,5 +37,5 @@
 
       try {
-        var newExample = Content.ParseExample(inputArgs, outputArgs);
+        var newExample = ParseExample(inputArgs, Content.InputArgumentTypes, outputArgs, Content.OutputArgumentTypes);
         newExample.CopyTo(example);
       }
@@ -40,13 +44,77 @@
 
         // reset entry
-        row.Cells[e.ColumnIndex].Value = e.ColumnIndex < Content.InputArgumentCount
+        row.Cells[e.ColumnIndex].Value = e.ColumnIndex < Content.InputArgumentTypes.Length
           ? example.InputArgs[e.ColumnIndex]
-          : example.OutputArgs[e.ColumnIndex - Content.InputArgumentCount];
+          : example.OutputArgs[e.ColumnIndex - Content.InputArgumentTypes.Length];
       }
     }
 
-    public new IBenchmarkSuiteDataDescriptor Content
+    private Example ParseExample(string[] inputArgs, ExampleArgumentType[] inputArgTypes, string[] outputArgs, ExampleArgumentType[] outputArgTypes) {
+      var example = new Example();
+
+      example.InputArgs = new string[inputArgs.Length];
+      for (var i = 0; i < inputArgs.Length; i++) {
+        var arg = inputArgs[i];
+        var type = inputArgTypes[i];
+
+        switch (type) {
+          case ExampleArgumentType.Bool:
+            example.InputBoolean = new[] { ExampleArgumentConverter.ConvertBoolean(arg) };
+            example.InputArgs[i] = arg;
+            break;
+          case ExampleArgumentType.Integer:
+            example.InputInt = new[] { ExampleArgumentConverter.ConvertInteger(arg) };
+            example.InputArgs[i] = arg;
+            break;
+          case ExampleArgumentType.IntegerCollection:
+            example.InputInt = ExampleArgumentConverter.ConvertIntegers(arg);
+            example.InputArgs[i] = string.Join(ValueSeparator, example.InputInt);
+            break;
+          case ExampleArgumentType.Float:
+            example.InputFloat = new[] { ExampleArgumentConverter.ConvertDouble(arg) };
+            example.InputArgs[i] = arg;
+            break;
+          case ExampleArgumentType.FloatCollection:
+            example.InputFloat = ExampleArgumentConverter.ConvertDoubles(arg);
+            example.InputArgs[i] = string.Join(ValueSeparator, example.InputFloat);
+            break;
+        }
+      }
+
+      example.OutputArgs = new string[outputArgs.Length];
+      for (var i = 0; i < outputArgs.Length; i++) {
+        var arg = outputArgs[i];
+        var type = outputArgTypes[i];
+
+        switch (type) {
+          case ExampleArgumentType.Bool:
+            example.OutputBoolean = new[] { ExampleArgumentConverter.ConvertBoolean(arg) };
+            example.OutputArgs[i] = arg;
+            break;
+          case ExampleArgumentType.Integer:
+            example.OutputInt = new[] { ExampleArgumentConverter.ConvertInteger(arg) };
+            example.OutputArgs[i] = arg;
+            break;
+          case ExampleArgumentType.IntegerCollection:
+            example.OutputInt = ExampleArgumentConverter.ConvertIntegers(arg);
+            example.OutputArgs[i] = string.Join(ValueSeparator, example.OutputInt);
+            break;
+          case ExampleArgumentType.Float:
+            example.OutputFloat = new[] { ExampleArgumentConverter.ConvertDouble(arg) };
+            example.OutputArgs[i] = arg;
+            break;
+          case ExampleArgumentType.FloatCollection:
+            example.OutputFloat = ExampleArgumentConverter.ConvertDoubles(arg);
+            example.OutputArgs[i] = string.Join(ValueSeparator, example.OutputFloat);
+            break;
+        }
+      }
+
+      return example;
+    }
+
+    public new Data Content
     {
-      get { return (IBenchmarkSuiteDataDescriptor)base.Content; }
+      get { return (Data)base.Content; }
       set
       {
@@ -69,9 +137,12 @@
       }
 
+      this.nameTextBox.Text = Content.Name;
+
       var cellTemplate = new DataGridViewTextBoxCell();
 
-      for (var i = 1; i <= Content.InputArgumentCount; i++) {
+      for (var i = 0; i < Content.InputArgumentTypes.Length; i++) {
+        var headerTypeName = ViewHelper.GetHeaderTypeName(Content.InputArgumentTypes[i]);
         var column = new DataGridViewColumn {
-          HeaderText = string.Format("Input {0}", i),
+          HeaderText = string.Format("Input {0} : {1}", i + 1, headerTypeName),
           AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill,
           CellTemplate = cellTemplate
@@ -81,7 +152,8 @@
       }
 
-      for (var i = 1; i <= Content.OutputArgumentCount; i++) {
+      for (var i = 0; i < Content.OutputArgumentTypes.Length; i++) {
+        var headerTypeName = ViewHelper.GetHeaderTypeName(Content.OutputArgumentTypes[i]);
         var column = new DataGridViewColumn {
-          HeaderText = string.Format("Output {0}", i),
+          HeaderText = string.Format("Output {0} : {1}", i + 1, headerTypeName),
           AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill,
           CellTemplate = cellTemplate
@@ -97,10 +169,10 @@
         row.CreateCells(dataGridView);
 
-        for (var i = 0; i < Content.InputArgumentCount; i++) {
-          row.Cells[i].Value = example.InputArgs[i];
+        for (var i = 0; i < Content.InputArgumentTypes.Length; i++) {
+          row.Cells[i].Value = ViewHelper.StringifyInput(Content.InputArgumentTypes[i], example, ValueSeparator);
         }
 
-        for (var i = 0; i < Content.OutputArgumentCount; i++) {
-          row.Cells[Content.InputArgumentCount + i].Value = example.OutputArgs[i];
+        for (var i = 0; i < Content.OutputArgumentTypes.Length; i++) {
+          row.Cells[Content.InputArgumentTypes.Length + i].Value = ViewHelper.StringifyOutput(Content.OutputArgumentTypes[i], example, ValueSeparator);
         }
 
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Views/ViewHelper.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Views/ViewHelper.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Views/ViewHelper.cs	(revision 14777)
@@ -0,0 +1,59 @@
+﻿namespace HeuristicLab.BenchmarkSuite.Views {
+  public static class ViewHelper {
+    public static string StringifyInput(ExampleArgumentType type, Example example, string valueSeparator) {
+      switch (type) {
+        case ExampleArgumentType.Integer:
+        case ExampleArgumentType.IntegerCollection: return string.Join(valueSeparator, example.InputInt);
+
+        case ExampleArgumentType.Float:
+        case ExampleArgumentType.FloatCollection: return string.Join(valueSeparator, example.InputFloat);
+
+        case ExampleArgumentType.Bool: return string.Join(valueSeparator, example.InputBoolean);
+        case ExampleArgumentType.Char: return string.Join(valueSeparator, example.InputChar);
+
+        case ExampleArgumentType.String:
+        case ExampleArgumentType.StringCollection: return string.Join(valueSeparator, example.InputString);
+        default: return string.Empty;
+      }
+    }
+
+    public static string StringifyOutput(ExampleArgumentType type, Example example, string valueSeparator) {
+      switch (type) {
+        case ExampleArgumentType.Integer:
+        case ExampleArgumentType.IntegerCollection: return string.Join(valueSeparator, example.OutputInt);
+
+        case ExampleArgumentType.Float:
+        case ExampleArgumentType.FloatCollection: return string.Join(valueSeparator, example.OutputFloat);
+
+        case ExampleArgumentType.Bool: return string.Join(valueSeparator, example.OutputBoolean);
+        case ExampleArgumentType.Char: return string.Join(valueSeparator, example.OutputChar);
+
+        case ExampleArgumentType.String:
+        case ExampleArgumentType.StringCollection: return string.Join(valueSeparator, example.OutputString);
+        default: return string.Empty;
+      }
+    }
+
+    private const string IntegerColumnHeader = "int";
+    private const string IntegersColumnHeader = "int[]";
+    private const string DoubleColumnHeader = "double";
+    private const string DoublesColumnHeader = "double[]";
+    private const string BooleanColumnHeader = "bool";
+    private const string CharColumnHeader = "char";
+    private const string StringColumnHeader = "string";
+    private const string StringsColumnHeader = "string[]";
+    public static string GetHeaderTypeName(ExampleArgumentType type) {
+      switch (type) {
+        case ExampleArgumentType.Integer: return IntegerColumnHeader;
+        case ExampleArgumentType.Float: return DoubleColumnHeader;
+        case ExampleArgumentType.Bool: return BooleanColumnHeader;
+        case ExampleArgumentType.Char: return CharColumnHeader;
+        case ExampleArgumentType.String: return StringColumnHeader;
+        case ExampleArgumentType.IntegerCollection: return IntegersColumnHeader;
+        case ExampleArgumentType.FloatCollection: return DoublesColumnHeader;
+        case ExampleArgumentType.StringCollection: return StringsColumnHeader;
+        default: return string.Empty;
+      }
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj	(revision 14777)
@@ -96,4 +96,5 @@
     </Reference>
     <Reference Include="System" />
+    <Reference Include="System.ComponentModel.DataAnnotations" />
     <Reference Include="System.Core" />
     <Reference Include="System.Drawing" />
@@ -117,8 +118,14 @@
     <Compile Include="Push\Creator\PointsBasedPushProgramCreator.cs" />
     <Compile Include="Push\Data\List\SkipList.cs" />
+    <Compile Include="Push\Data\Pool\IPooledObject.cs" />
     <Compile Include="Push\Data\Pool\ManagedPoolProvider.cs" />
     <Compile Include="Push\Data\Pool\ObjectPool.cs" />
+    <Compile Include="Push\Data\Pool\PooledList.cs" />
+    <Compile Include="Push\Data\Tree\Tree.cs" />
+    <Compile Include="Push\Data\Tree\TreeExtensions.cs" />
+    <Compile Include="Push\Data\Tree\TreeNode.cs" />
     <Compile Include="Push\Exporter\Exporter.cs" />
     <Compile Include="Push\Expressions\BooleanExpressions.cs" />
+    <Compile Include="Push\Expressions\CharExpressions.cs" />
     <Compile Include="Push\Expressions\CodeExpressions.cs" />
     <Compile Include="Push\Expressions\DefineExpressions.cs" />
@@ -127,4 +134,5 @@
     <Compile Include="Push\Expressions\DoTimesExpressions.cs" />
     <Compile Include="Push\Expressions\DuplicateExpressions.cs" />
+    <Compile Include="Push\Expressions\EmptyExpresssions.cs" />
     <Compile Include="Push\Expressions\EqualsExpressions.cs" />
     <Compile Include="Push\Expressions\ExecExpressions.cs" />
@@ -137,5 +145,4 @@
     <Compile Include="Push\Expressions\NameExpressions.cs" />
     <Compile Include="Push\Expressions\PopExpressions.cs" />
-    <Compile Include="Push\Expressions\PushProgram.bk.cs" />
     <Compile Include="Push\Expressions\PushExpressions.cs" />
     <Compile Include="Push\Expressions\PushProgram.cs" />
@@ -147,9 +154,12 @@
     <Compile Include="Push\Expressions\StatefulExpression.cs" />
     <Compile Include="Push\Expressions\StatelessExpression.cs" />
+    <Compile Include="Push\Expressions\StringExpressions.cs" />
     <Compile Include="Push\Expressions\SwapExpressions.cs" />
     <Compile Include="Push\Expressions\YankDuplicateExpressions.cs" />
     <Compile Include="Push\Expressions\YankExpressions.cs" />
-    <Compile Include="Push\Generators\CodeGenerator.cs" />
+    <Compile Include="Push\Generators\LinearCodeGenerator.cs" />
+    <Compile Include="Push\Generators\RecursiveCodeGenerator.cs" />
     <Compile Include="Push\Generators\NameGenerator.cs" />
+    <Compile Include="Push\Interpreter\InterpreterPoolContainer.cs" />
     <Compile Include="Push\Interpreter\IPushInterpreter.cs" />
     <Compile Include="Push\Configuration\IReadonlyPushConfiguration.cs" />
@@ -160,13 +170,14 @@
     <Compile Include="Push\Parser\PushParser.cs" />
     <Compile Include="Push\Creator\IPushProgramCreator.cs" />
+    <Compile Include="Push\Problem\DataBounds.cs" />
     <Compile Include="Push\Problem\PushEncoding.cs" />
+    <Compile Include="Push\Problem\PushEvaluator.cs" />
     <Compile Include="Push\Problem\PushProblem.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="Push\Simplifier\ISimplifier.cs" />
-    <Compile Include="Push\Simplifier\RandomSimplifier.cs" />
     <Compile Include="Push\Problem\PushSolution.cs" />
+    <Compile Include="Push\Simplifier\Simplifier.cs" />
     <Compile Include="Push\Stack\IStack.cs" />
     <Compile Include="Push\Stack\PushStack.cs" />
-    <Compile Include="Push\Stack\StackType.cs" />
+    <Compile Include="Push\Stack\StackTypes.cs" />
     <Compile Include="Push\Views\ExpressionSelectionView.cs">
       <SubType>UserControl</SubType>
@@ -200,7 +211,5 @@
     </ProjectReference>
   </ItemGroup>
-  <ItemGroup>
-    <Folder Include="Push\Solution\" />
-  </ItemGroup>
+  <ItemGroup />
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <PropertyGroup>
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj.user
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj.user	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj.user	(revision 14777)
@@ -2,5 +2,5 @@
 <Project ToolsVersion="14.0" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
   <PropertyGroup>
-    <ProjectView>ProjectFiles</ProjectView>
+    <ProjectView>ShowAllFiles</ProjectView>
   </PropertyGroup>
   <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|AnyCPU'">
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Attributes/PushExpressionAttriubte.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Attributes/PushExpressionAttriubte.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Attributes/PushExpressionAttriubte.cs	(revision 14777)
@@ -6,9 +6,11 @@
   [AttributeUsage(AttributeTargets.Class)]
   public class PushExpressionAttribute : Attribute {
-    public readonly StackType StackType;
+    public readonly StackTypes StackTypes;
+    public readonly StackTypes AdditionalStackDependencies;
     public readonly string ExpressionName;
 
-    public PushExpressionAttribute(StackType stackType, string expressionName) {
-      this.StackType = stackType;
+    public PushExpressionAttribute(StackTypes stackTypes, string expressionName, StackTypes additionalStackDependencies = default(StackTypes)) {
+      this.StackTypes = stackTypes;
+      this.AdditionalStackDependencies = additionalStackDependencies;
       this.ExpressionName = expressionName;
     }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IEnabledExpressionsConfiguration.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IEnabledExpressionsConfiguration.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IEnabledExpressionsConfiguration.cs	(revision 14777)
@@ -22,8 +22,8 @@
     IList<string> EnabledExpressions { get; }
 
-    void EnableStack(StackType type);
-    void DisableStack(StackType type);
-    void EnableExpressionOfStack(StackType type);
-    void DisableExpressionOfStack(StackType type);
+    void EnableStack(StackTypes types);
+    void DisableStack(StackTypes types);
+    void EnableExpressionOfStack(StackTypes types);
+    void DisableExpressionOfStack(StackTypes types);
     void EnableExpression(string name);
     void DisableExpression(string name);
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IReadonlyPushConfiguration.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IReadonlyPushConfiguration.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IReadonlyPushConfiguration.cs	(revision 14777)
@@ -2,8 +2,12 @@
   using System.Collections.Generic;
 
-  public interface IReadonlyPushConfiguration {
+  using HeuristicLab.Common;
+
+  public interface IReadOnlyPushConfiguration : IDeepCloneable {
     bool IsBooleanStackEnabled { get; }
     bool IsIntegerStackEnabled { get; }
     bool IsFloatStackEnabled { get; }
+    bool IsCharStackEnabled { get; }
+    bool IsStringStackEnabled { get; }
     bool IsCodeStackEnabled { get; }
     bool IsNameStackEnabled { get; }
@@ -11,4 +15,5 @@
     int EvalPushLimit { get; }
     int MaxDepth { get; }
+    int MaxStringLength { get; }
     int MaxPointsInProgram { get; }
     int MaxPointsInRandomExpression { get; }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfiguration.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfiguration.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfiguration.cs	(revision 14777)
@@ -12,11 +12,13 @@
 
   [StorableClass]
-  public class PushConfiguration : NamedItem, IReadonlyPushConfiguration, IEnabledExpressionsConfiguration {
-    private static readonly string itemName = "PushGP Configuration";
+  public class PushConfiguration : NamedItem, IReadOnlyPushConfiguration, IEnabledExpressionsConfiguration {
+    private static readonly string itemName = "Push Configuration";
 
     public PushConfiguration() {
-      this.EvalPushLimit = 4096;
+      this.EvalPushLimit = 1024;
       this.MaxPointsInProgram = 128;
       this.MaxPointsInRandomExpression = 64;
+      this.MaxDepth = 4;
+      this.MaxStringLength = 64;
 
       this.TopLevelPushCode = true;
@@ -30,9 +32,11 @@
       this.ErcProbability = 0.2;
 
-      this.EnabledExpressions = ExpressionTable.ExpressionNames.ToList();
+      this.enabledExpressions = ExpressionTable.ExpressionNames.ToList();
     }
 
     [StorableConstructor]
-    public PushConfiguration(bool deserializing) : base(deserializing) { }
+    public PushConfiguration(bool deserializing)
+      : base(deserializing) {
+    }
 
     public PushConfiguration(PushConfiguration origin, Cloner cloner) : base(origin, cloner) {
@@ -42,4 +46,6 @@
       this.MaxPointsInProgram = origin.MaxPointsInProgram;
       this.MaxPointsInRandomExpression = origin.MaxPointsInRandomExpression;
+      this.MaxDepth = origin.MaxDepth;
+      this.MaxStringLength = origin.MaxStringLength;
 
       this.TopLevelPushCode = origin.TopLevelPushCode;
@@ -63,8 +69,22 @@
     public event EventHandler<EnabledExpressionsChangedEventArgs> EnabledExpressionsChanged;
 
-    [Storable]
-    public IList<string> EnabledExpressions { get; private set; }
-
-    IReadOnlyList<string> IReadonlyPushConfiguration.EnabledExpressions { get { return this.EnabledExpressions as IReadOnlyList<string>; } }
+
+    private readonly List<string> enabledExpressions = new List<string>();
+
+    [Storable]
+    public IList<string> EnabledExpressions
+    {
+      get
+      {
+        return enabledExpressions;
+      }
+      set
+      {
+        enabledExpressions.Clear();
+        enabledExpressions.AddRange(value);
+      }
+    }
+
+    IReadOnlyList<string> IReadOnlyPushConfiguration.EnabledExpressions { get { return this.EnabledExpressions as IReadOnlyList<string>; } }
 
     [Storable]
@@ -84,6 +104,6 @@
         this.isBooleanStackEnabled = value;
 
-        if (this.isBooleanStackEnabled) EnableExpressionOfStack(StackType.Boolean);
-        else DisableExpressionOfStack(StackType.Boolean);
+        if (this.isBooleanStackEnabled) EnableExpressionOfStack(StackTypes.Boolean);
+        else DisableExpressionOfStack(StackTypes.Boolean);
       }
     }
@@ -105,6 +125,6 @@
         this.isIntegerStackEnabled = value;
 
-        if (this.isIntegerStackEnabled) EnableExpressionOfStack(StackType.Integer);
-        else DisableExpressionOfStack(StackType.Integer);
+        if (this.isIntegerStackEnabled) EnableExpressionOfStack(StackTypes.Integer);
+        else DisableExpressionOfStack(StackTypes.Integer);
       }
     }
@@ -126,6 +146,6 @@
         this.isFloatStackEnabled = value;
 
-        if (this.isFloatStackEnabled) EnableExpressionOfStack(StackType.Float);
-        else DisableExpressionOfStack(StackType.Float);
+        if (this.isFloatStackEnabled) EnableExpressionOfStack(StackTypes.Float);
+        else DisableExpressionOfStack(StackTypes.Float);
       }
     }
@@ -147,6 +167,6 @@
         this.isCodeStackEnabled = value;
 
-        if (this.isCodeStackEnabled) EnableExpressionOfStack(StackType.Code);
-        else DisableExpressionOfStack(StackType.Code);
+        if (this.isCodeStackEnabled) EnableExpressionOfStack(StackTypes.Code);
+        else DisableExpressionOfStack(StackTypes.Code);
       }
     }
@@ -168,6 +188,48 @@
         this.isExecStackEnabled = value;
 
-        if (this.isExecStackEnabled) EnableExpressionOfStack(StackType.Exec);
-        else DisableExpressionOfStack(StackType.Exec);
+        if (this.isExecStackEnabled) EnableExpressionOfStack(StackTypes.Exec);
+        else DisableExpressionOfStack(StackTypes.Exec);
+      }
+    }
+
+    [Storable]
+    private bool isCharStackEnabled = true;
+
+    public bool IsCharStackEnabled
+    {
+      get
+      {
+        return this.isCharStackEnabled;
+      }
+
+      set
+      {
+        if (this.isCharStackEnabled == value) return;
+
+        this.isCharStackEnabled = value;
+
+        if (this.isCharStackEnabled) EnableExpressionOfStack(StackTypes.Char);
+        else DisableExpressionOfStack(StackTypes.Char);
+      }
+    }
+
+    [Storable]
+    private bool isStringStackEnabled = true;
+
+    public bool IsStringStackEnabled
+    {
+      get
+      {
+        return this.isStringStackEnabled;
+      }
+
+      set
+      {
+        if (this.isStringStackEnabled == value) return;
+
+        this.isStringStackEnabled = value;
+
+        if (this.isStringStackEnabled) EnableExpressionOfStack(StackTypes.String);
+        else DisableExpressionOfStack(StackTypes.String);
       }
     }
@@ -189,6 +251,6 @@
         this.isNameStackEnabled = value;
 
-        if (this.isNameStackEnabled) EnableExpressionOfStack(StackType.Name);
-        else DisableExpressionOfStack(StackType.Name);
+        if (this.isNameStackEnabled) EnableExpressionOfStack(StackTypes.Name);
+        else DisableExpressionOfStack(StackTypes.Name);
       }
     }
@@ -244,4 +306,7 @@
     public bool TopLevelPopCode { get; set; }
 
+    [Storable]
+    public int MaxStringLength { get; set; }
+
     /// <summary>
     ///     The minimum INTEGER that will be produced as an ephemeral random INTEGER constant or from a call to INTEGER.RAND.
@@ -276,12 +341,12 @@
     public double NewErcNameProbability { get; set; }
 
-    public void EnableExpressionOfStack(StackType type) {
-      foreach (var name in ExpressionTable.StackTypeToNamesTable[type]) {
+    public void EnableExpressionOfStack(StackTypes types) {
+      foreach (var name in ExpressionTable.StackTypeToNamesTable[types]) {
         EnableExpression(name);
       }
     }
 
-    public void DisableExpressionOfStack(StackType type) {
-      foreach (var name in ExpressionTable.StackTypeToNamesTable[type]) {
+    public void DisableExpressionOfStack(StackTypes types) {
+      foreach (var name in ExpressionTable.StackTypeToNamesTable[types]) {
         DisableExpression(name);
       }
@@ -322,33 +387,39 @@
     }
 
-    public void EnableStack(StackType type) {
-      SetStack(type, true);
-    }
-
-    public void DisableStack(StackType type) {
-      SetStack(type, false);
-    }
-
-    private void SetStack(StackType type, bool value) {
-      switch (type) {
-        case StackType.Boolean:
+    public void EnableStack(StackTypes types) {
+      SetStack(types, true);
+    }
+
+    public void DisableStack(StackTypes types) {
+      SetStack(types, false);
+    }
+
+    public void SetStack(StackTypes types, bool value) {
+      switch (types) {
+        case StackTypes.Boolean:
           IsBooleanStackEnabled = value;
           break;
-        case StackType.Integer:
+        case StackTypes.Integer:
           IsIntegerStackEnabled = value;
           break;
-        case StackType.Float:
+        case StackTypes.Float:
           IsFloatStackEnabled = value;
           break;
-        case StackType.Name:
+        case StackTypes.Name:
           IsNameStackEnabled = value;
           break;
-        case StackType.Code:
+        case StackTypes.Code:
           IsCodeStackEnabled = value;
           break;
-        case StackType.Exec:
+        case StackTypes.Exec:
           this.IsExecStackEnabled = value;
           break;
-        default: throw new InvalidOperationException("Stacktype unkown");
+        case StackTypes.Char:
+          this.IsCharStackEnabled = value;
+          break;
+        case StackTypes.String:
+          this.IsStringStackEnabled = value;
+          break;
+        default: throw new InvalidOperationException("Stacktype unknown");
       }
     }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Creator/IPushProgramCreator.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Creator/IPushProgramCreator.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Creator/IPushProgramCreator.cs	(revision 14777)
@@ -13,5 +13,5 @@
   public interface IPushProgramCreator : ISolutionCreator
   {
-    PushProgram CreateProgram(IRandom random, IReadonlyPushConfiguration config);
+    PushProgram CreateProgram(IRandom random, IReadOnlyPushConfiguration config);
   }
 }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Creator/PointsBasedPushProgramCreator.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Creator/PointsBasedPushProgramCreator.cs	(revision 14747)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Creator/PointsBasedPushProgramCreator.cs	(revision 14777)
@@ -23,5 +23,5 @@
 //    }
 
-//    public PushProgram CreateProgram(IRandom random, IReadonlyPushConfiguration config) {
+//    public PushProgram CreateProgram(IRandom random, IReadOnlyPushConfiguration config) {
 //      return CodeGenerator.RandomProgram(10, random, config);
 //    }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/IPooledObject.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/IPooledObject.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/IPooledObject.cs	(revision 14777)
@@ -0,0 +1,5 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Data.Pool {
+  public interface IPooledObject {
+    void Reset();
+  }
+}
